--------------------------------------------------------------------
-- Events
--------------------------------------------------------------------


---------------------------
-- event functions
---------------------------
function Glance.Functions.setAddOnEvents()
	function Glance.Events:ADDON_LOADED(...)  end
	function Glance.Events:BN_FRIEND_ACCOUNT_OFFLINE(...) 		Glance.Functions.updateFriends() end
	function Glance.Events:BN_FRIEND_ACCOUNT_ONLINE(...) 		Glance.Functions.updateFriends() end
	function Glance.Events:CHAT_MSG_SKILL(...) 					Glance.Functions.updateProfessions() end
	function Glance.Events:COMPANION_LEARNED(...) 				Glance.Functions.resetMountList() Glance.Functions.updateMounts() Glance.Functions.resetPetList() Glance.Functions.updatePets()end
	function Glance.Events:FRIENDLIST_UPDATE(...) 				Glance.Functions.updateFriends() end
	function Glance.Events:GUILD_ROSTER_UPDATE(...) 			Glance.Functions.updateGuild() end
	function Glance.Events:HONOR_CURRENCY_UPDATE(...) 			Glance.Functions.updateEmblems() end
	function Glance.Events:KNOWN_CURRENCY_TYPES_UPDATE(...) 	Glance.Functions.updateEmblems() end
	function Glance.Events:LFG_COMPLETION_REWARD(...) 			Glance.Functions.updateEmblems() end
	function Glance.Events:MERCHANT_SHOW(...) 					Glance.Functions.repairArmor() end
	function Glance.Events:PLAYER_GUILD_UPDATE(...) 			Glance.Functions.updateGuild() end
	function Glance.Events:PLAYER_MONEY(...) 					Glance.Functions.updateCurrency() end
	function Glance.Events:PLAYER_XP_UPDATE(...) 				Glance.Functions.updateXP() end
	function Glance.Events:UNIT_DAMAGE(...) 					Glance.Functions.updateArmor() end
	function Glance.Events:UPDATE_FACTION(...) 					Glance.Functions.updateRep() end
	function Glance.Events:UPDATE_INVENTORY_DURABILITY(...) 	Glance.Functions.updateArmor() end
end

---------------------------
-- register events
---------------------------
function Glance.Functions.registerEvents()
	for k, v in pairs(Glance.Events) do
		Glance.Frames.mainFrame:RegisterEvent(k)
	end
end

---------------------------
-- button event handlers
---------------------------
function Glance.Functions.setButtonEvents()
	Glance.Buttons.Gold:SetScript("OnEnter", function(...) if Glance_Options.showGold then Glance.Functions.setTT(Glance.Buttons.Gold) end end)
	Glance.Buttons.Gold:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Emblems:SetScript("OnEnter", function(...) if Glance_Options.showEmblems then Glance.Functions.setTT(Glance.Buttons.Emblems) end end)
	Glance.Buttons.Emblems:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Emblems:SetScript("OnClick", function(...) if Glance_Options.showEmblems then ToggleCharacter("TokenFrame") end end)
	Glance.Buttons.Friends:SetScript("OnEnter", function(...) if Glance_Options.showFriends then Glance.Functions.setTT(Glance.Buttons.Friends) end end)
	Glance.Buttons.Friends:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Friends:SetScript("OnClick", function(...) if Glance_Options.showFriends then ToggleFriendsFrame(1) end end)
	Glance.Buttons.Guild:SetScript("OnEnter", function(...) if Glance_Options.showGuild then Glance.Functions.setTT(Glance.Buttons.Guild) end end)
	Glance.Buttons.Guild:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Guild:SetScript("OnClick", function(...) if Glance_Options.showGuild then ToggleGuildFrame(1) end end)
	Glance.Buttons.Armor:SetScript("OnEnter", function(...) if Glance_Options.showArmor then Glance.Functions.setTT(Glance.Buttons.Armor) end end)
	Glance.Buttons.Armor:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.XP:SetScript("OnEnter", function(...) if Glance_Options.showXP then Glance.Functions.setTT(Glance.Buttons.XP) end end)
	Glance.Buttons.XP:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Rep:SetScript("OnEnter", function(...) if Glance_Options.showRep then Glance.Functions.setTT(Glance.Buttons.Rep) end end)
	Glance.Buttons.Rep:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Lag:SetScript("OnEnter", function(...) if Glance_Options.showLag then Glance.Functions.setTT(Glance.Buttons.Lag) end end)
	Glance.Buttons.Lag:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Lag:SetScript("OnClick", function(...) if Glance_Options.showLag then ShowUIPanel(ACP_AddonList) end end)
	Glance.Buttons.Mounts:SetScript("OnEnter", function(...) if Glance_Options.showMounts then Glance.Functions.setTT(Glance.Buttons.Mounts) end end)
	Glance.Buttons.Mounts:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Pets:SetScript("OnEnter", function(...) if Glance_Options.showPets then Glance.Functions.setTT(Glance.Buttons.Pets) end end)
	Glance.Buttons.Pets:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.WG:SetScript("OnEnter", function(...) if Glance_Options.showWG then Glance.Functions.setTT(Glance.Buttons.WG) end end)
	Glance.Buttons.WG:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.TB:SetScript("OnEnter", function(...) if Glance_Options.showTB then Glance.Functions.setTT(Glance.Buttons.TB) end end)
	Glance.Buttons.TB:SetScript("OnLeave", Glance.Functions.hideTooltip)
	Glance.Buttons.Professions:SetScript("OnEnter", function(...) if Glance_Options.showProfessions then Glance.Functions.setTT(Glance.Buttons.Professions) end end)
	Glance.Buttons.Professions:SetScript("OnLeave", Glance.Functions.hideTooltip)

	Glance.Buttons.Rep:SetScript("OnClick", function(...) if Glance_Options.showRep then Glance.Functions.menuToggleRep(Glance.Buttons.Rep, button, ...) Glance.Functions.hideTooltip() end end)
	Glance.Buttons.Professions:SetScript("OnClick", function(...) if Glance_Options.showProfessions then Glance.Functions.menuToggleProfession(Glance.Buttons.Professions, button, ...) Glance.Functions.hideTooltip() end end)
	Glance.Buttons.Mounts:SetScript("OnClick", function(...) if Glance_Options.showMounts then Glance.Functions.menuToggleMount(Glance.Buttons.Mounts, button, ...) Glance.Functions.hideTooltip() end end)
	Glance.Buttons.Pets:SetScript("OnClick", function(...) if Glance_Options.showPets then Glance.Functions.menuTogglePet(Glance.Buttons.Pets, button, ...) Glance.Functions.hideTooltip() end end)
end

---------------------------
-- onEvent/onUpdate handler
---------------------------
function Glance.Functions.setAddOnHandlers()
	Glance.Frames.mainFrame:SetScript("OnEvent", function(self, event, arg1)
		if event=="ADDON_LOADED" and arg1 == "Glance" then
			Glance.Functions.sendMSG("v"..GetAddOnMetadata("Glance","Version").." loaded.  Type '/glance options' to set your preferences.")
			Glance.Functions.loadDefaultVariables()
			Glance.Functions.moveUI()
			Glance.Functions.createOptionsPanel()
			Glance.Functions.setOptionValues()
		else
			if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cff00ff00EVT: "..event) end
			Glance.Events[event](self, event, arg1)
			Glance.Functions.moveUI()
		end
	end)

	Glance.Frames.mainFrame:SetScript("OnUpdate", function(self, elapsed)
		Glance.Variables.TimeSinceLastUpdate = Glance.Variables.TimeSinceLastUpdate + elapsed
		if Glance.Variables.Delay then
			Glance.Functions.resetMountList()
			Glance.Functions.resetPetList()
			Glance.Functions.updateAll()
			Glance.Variables.Delay = false
		end
		if Glance.Variables.TimeSinceLastUpdate >= 1 then
			GuildRoster()
			Glance.Functions.updateEmblems()
			Glance.Functions.updateLag()
			Glance.Functions.updateFPS()
			Glance.Functions.updateLocation()
			Glance.Functions.updateClock()
			if not IsInInstance() then
				Glance.Functions.updateWG();
				Glance.Functions.updateTB();
			end
			Glance.Variables.TimeSinceLastUpdate = 0
		end
	end)
end
