--------------------------------------------------------------------
-- Frames
--------------------------------------------------------------------

function Glance.Functions.loadFrame()
	---------------------------
	-- parent frame
	---------------------------
	Glance.Frames.mainFrame = CreateFrame("FRAME", "Glance", UIParent)
	Glance.Frames.mainFrame:SetWidth(Glance.Variables.screenWidth)
	Glance.Frames.mainFrame:SetHeight(13)
	Glance.Frames.mainFrame:SetPoint("TOPLEFT", 0, 0)
	Glance.Frames.mainFrame:SetPoint("TOPRIGHT", 0, 0)

	---------------------------
	-- parent frame alpha
	---------------------------
	local t = Glance.Frames.mainFrame:CreateTexture(nil, "ARTWORK")
	t:SetTexture(0, 0, 0, .5)
	t:SetAllPoints(Glance.Frames.mainFrame)
	Glance.Frames.mainFrame.texture = t

	---------------------------
	-- parent frame border
	---------------------------
	local t2 = Glance.Frames.mainFrame:CreateTexture(nil, "BORDER")
	t2:SetTexture(.4, .4, .4)
	t2:SetPoint("TOPLEFT", Glance.Frames.mainFrame, "BOTTOMLEFT", 0, 0)
	t2:SetPoint("TOPRIGHT", Glance.Frames.mainFrame, "BOTTOMRIGHT", 0, 0)
	t2:SetWidth(Glance.Variables.screenWidth)
	t2:SetHeight(1)

	---------------------------
	-- create buttons
	---------------------------
	Glance.Buttons.Gold = Glance.Functions.createButton(Glance.Frames.mainFrame,50,GetCoinTextureString(GetMoney(),0),5,"LEFT")
	Glance.Buttons.Emblems = Glance.Functions.createButton(Glance.Buttons.Gold,50,"Emblems",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Friends = Glance.Functions.createButton(Glance.Buttons.Emblems,50,"Friends",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Guild = Glance.Functions.createButton(Glance.Buttons.Friends,50,"Guild",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Armor = Glance.Functions.createButton(Glance.Buttons.Guild,50,"Armor",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.XP = Glance.Functions.createButton(Glance.Buttons.Armor,50,"XP",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Rep = Glance.Functions.createButton(Glance.Buttons.XP,50,"REP",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Professions = Glance.Functions.createButton(Glance.Buttons.Rep,50,"Professions",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Lag = Glance.Functions.createButton(Glance.Buttons.Professions,50,"LAG",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.FPS = Glance.Functions.createButton(Glance.Buttons.Lag,50,"FPS",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Mounts = Glance.Functions.createButton(Glance.Buttons.FPS,50,"Mounts",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.Pets = Glance.Functions.createButton(Glance.Buttons.Mounts,50,"Pets",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.WG = Glance.Functions.createButton(Glance.Buttons.Pets,50,"Wintergrasp",Glance.Variables.spacer,"RIGHT")
	Glance.Buttons.TB = Glance.Functions.createButton(Glance.Buttons.WG,50,"Tol Barad",Glance.Variables.spacer,"RIGHT")

	---------------------------
	-- Time Overlay
	---------------------------
	Glance.Overlays.Time = Glance.Frames.mainFrame:CreateFontString(nil, "OVERLAY")
	Glance.Overlays.Time:SetFont(Glance.Variables.fnt_file, Glance.Variables.fnt_height)
	Glance.Overlays.Time:SetPoint("RIGHT", Glance.Frames.mainFrame, "RIGHT", 0, 0)

	---------------------------
	-- location Overlay
	---------------------------
	Glance.Overlays.Location = Glance.Frames.mainFrame:CreateFontString(nil, "OVERLAY")
	Glance.Overlays.Location:SetFont(Glance.Variables.fnt_file, Glance.Variables.fnt_height)
	Glance.Overlays.Location:SetPoint("RIGHT", Glance.Overlays.Time, "LEFT", Glance.Variables.spacer, 0)
end

---------------------------
-- configure buttons
---------------------------
function Glance.Functions.createButton(parent,width,text,space,position)
	local btn = CreateFrame("BUTTON", "Glance_"..text.."_btn", Glance.Frames.mainFrame)
	btn:SetWidth(width)
	btn:SetHeight(Glance.Variables.btn_height)
	local fs = btn:CreateFontString()
	fs:SetFont(Glance.Variables.fnt_file, Glance.Variables.fnt_height)
	btn:SetFontString(fs)
	btn:SetText(text)
	btn:SetPoint("LEFT", parent, position, space, 0)
	return btn
end