--------------------------------------------------------------------
-- Tooltips
--------------------------------------------------------------------


---------------------------
-- create tooltip
---------------------------
function Glance.Functions.setTT(owner)
	GameTooltip:SetOwner(owner, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", owner, "BOTTOMLEFT", 0, -5)
	if owner == Glance.Buttons.Emblems then Glance.Functions.setTTEmblems()
	elseif owner == Glance.Buttons.Gold then Glance.Functions.setTTGold() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTGold()") end
	elseif owner == Glance.Buttons.Friends then Glance.Functions.setTTFriends() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTFriends()") end
	elseif owner == Glance.Buttons.Guild then Glance.Functions.setTTGuild() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTGuild()") end
	elseif owner == Glance.Buttons.Armor then Glance.Functions.setTTArmor() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTArmor()") end
	elseif owner == Glance.Buttons.XP then Glance.Functions.setTTXP() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTXP()") end
	elseif owner == Glance.Buttons.Rep then Glance.Functions.setTTRep() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTRep()") end
	elseif owner == Glance.Buttons.Lag then Glance.Functions.setTTLAG() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTLAG()") end
	elseif owner == Glance.Buttons.Mounts then Glance.Functions.setTTMounts() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTMounts()") end
	elseif owner == Glance.Buttons.Pets then Glance.Functions.setTTPets() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTPets()") end
	elseif owner == Glance.Buttons.WG then Glance.Functions.setTTWG() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTWG()") end
	elseif owner == Glance.Buttons.TB then Glance.Functions.setTTTB() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTTB()") end
	elseif owner == Glance.Buttons.Professions then Glance.Functions.setTTProfessions() if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTProfessions()") end
	end
	GameTooltip:Show()
end

---------------------------
-- tooltip text
---------------------------
function Glance.Functions.TTST(text,color)
	GameTooltip:SetText(text, Glance.Arrays.colors[color][1], Glance.Arrays.colors[color][2], Glance.Arrays.colors[color][3])
end
function Glance.Functions.TTAL(text,color)
	GameTooltip:AddLine(text, Glance.Arrays.colors[color][1], Glance.Arrays.colors[color][2], Glance.Arrays.colors[color][3])
end
function Glance.Functions.TTALW(text,color)
	GameTooltip:AddLine(text, Glance.Arrays.colors[color][1], Glance.Arrays.colors[color][2], Glance.Arrays.colors[color][3], 1)
end
function Glance.Functions.TTAD(text1,text2,col1,col2)
	GameTooltip:AddDoubleLine(text1, text2, Glance.Arrays.colors[col1][1], Glance.Arrays.colors[col1][2], Glance.Arrays.colors[col1][3], Glance.Arrays.colors[col2][1], Glance.Arrays.colors[col2][2], Glance.Arrays.colors[col2][3])
end

---------------------------
-- hide tooltip
---------------------------
function Glance.Functions.hideTooltip(self)
	GameTooltip:Hide()
end

---------------------------
-- Gold tooltip
---------------------------
function Glance.Functions.setTTGold()
	local htotal, atotal, total = 0, 0, 0
		local englishFaction, localizedFaction = UnitFactionGroup("player")
	Glance.Functions.TTST("Gold in Account","GLD")
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("Horde Gold","GLD")
	for i=1,#Glance_Global.HordeGold do
		local name,count = unpack(Glance_Global.HordeGold[i])
		Glance.Functions.TTAD(name,GetCoinTextureString(count,0),"WHT","WHT")
		htotal = htotal + count
		total = total + count
	end
	Glance.Functions.TTAD("Horde Total",GetCoinTextureString(htotal,0),"GRN","WHT")
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("Alliance Gold","GLD")
	for i=1,#Glance_Global.AllianceGold do
		local name,count = unpack(Glance_Global.AllianceGold[i])
		Glance.Functions.TTAD(name,GetCoinTextureString(count,0),"WHT","WHT")
		atotal = atotal + count
		total = total + count
	end
	Glance.Functions.TTAD("Alliance Total",GetCoinTextureString(atotal,0),"GRN","WHT")
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAD("Total Gold",GetCoinTextureString(total,0),"GRN","WHT")
	if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTGold()") end
end

---------------------------
-- Emblems tooltip
---------------------------
function Glance.Functions.setTTEmblems()
	local hasEmblems = false
	Glance.Functions.TTST("Emblems","GLD")
	for i=1, GetCurrencyListSize() do
		local name,_,_,_,_,count,_,icon,_ = GetCurrencyListInfo(i)
		Glance.Functions.TTAD(name,count,"WHT","GRN")
		hasEmblems = true
	end
	if not hasEmblems then
		Glance.Functions.TTAL("|rYou have no emblems","WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to open the Currency tab.)","WHT")
	if Glance.Variables.Debug then Glance.Functions.sendMSG("DBG: |cFFf4890bTLT: Glance.Functions.setTTEmblems()") end
end

---------------------------
-- Friends tooltip
---------------------------
function Glance.Functions.setTTFriends()
	local _,numFriends = GetNumFriends()
	local _,bnFriends = BNGetNumFriends()
	local friends = numFriends + bnFriends
	Glance.Functions.TTAL(numFriends.." Friend(s) Online","GLD")
	for i = 0, GetNumFriends() do
		local name, level, class, area, connected, status, note = GetFriendInfo(i)
		if connected then
			Glance.Functions.TTAD(name.." ("..level.." "..class..")", area, string.upper(class), "WHT")
		end
	end
	Glance.Functions.TTAL(" ","WHT")
	Glance.Functions.TTAL(bnFriends.." BattleNet Friend(s) Online","GLD")
	for j = 1, BNGetNumFriends() do
		local presenceID, givenName, surname, _,_,_,isOnline = BNGetFriendInfo(j)
		local _,toonName,_,realmName,_,race,class,_,zoneName,level,_,_,_ = BNGetToonInfo(presenceID)
		if isOnline then
			Glance.Functions.TTAD(givenName.." "..surname, toonName.." ("..level.." "..race.." "..class..") "..zoneName, "WHT", string.upper(class))
		end
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to open the Friends tab.)","WHT")
end

---------------------------
-- Guild tooltip
---------------------------
function Glance.Functions.setTTGuild()
	if IsInGuild() then
		local total = GetNumGuildMembers(true)
		local onlineTotal = 0
		local offlineTotal = 0
		local guild = {}
		for i = 1, total do
			local name,_, _,level,class,zone,_,_,online,_,_ = GetGuildRosterInfo(i)
			if online then
				onlineTotal = onlineTotal + 1
				table.insert(guild, {name, level, class, zone})
			else
				offlineTotal = offlineTotal + 1
			end
		end
		Glance.Functions.TTST(onlineTotal.."/"..total.." Guild Member(s) Online", "GLD")
		table.sort(guild, function(a, b) return a[1] < b[1] end)
		for k, v in pairs(guild) do
			Glance.Functions.TTAD(v[1].." ("..v[2].." "..v[3]..")", v[4], string.upper(v[3]), "WHT")
		end
		wipe(guild)
	else
		Glance.Functions.TTST("Guild Member(s)", "GLD")
		Glance.Functions.TTAL("|rYou are not in a guild.", "WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to open the Guild tab.)","WHT")
end

---------------------------
-- Armor tooltip
---------------------------
function Glance.Functions.setTTArmor()
	Glance.Functions.TTST("Armor", "GLD")
	CreateFrame("GameTooltip","Glance_Tooltip_Armor",UIParent,"GameTooltipTemplate")
	local TotalRepairCost = 0
	local itemLevel = GetAverageItemLevel()
	for i=1, 11 do
		local slotId, textureName = GetInventorySlotInfo(Glance.Arrays.slotItems[i])
		local hasItem, hasCooldown, repairCost = Glance_Tooltip_Armor:SetInventoryItem("player", slotId);
		if hasItem then
			TotalRepairCost = TotalRepairCost + (repairCost or 0)
		end
	end
	Glance_Tooltip_Armor:Hide();
	if TotalRepairCost > 0 then
		Glance.Functions.TTAL("The total cost to repair your armor is: "..GetCoinTextureString(TotalRepairCost,0), "WHT")
	else
		Glance.Functions.TTAL("Your armor is fully repaired.", "WHT")
	end
	Glance.Functions.TTAL("Your average item level is "..math.floor(itemLevel)..".", "WHT")
end

---------------------------
-- XP tooltip
---------------------------
function Glance.Functions.setTTXP()
	if UnitLevel("player") < 85 then
		local thisLVL, thisXP, nextXP, restXP = UnitLevel("player"), UnitXP('player'), UnitXPMax('player'), GetXPExhaustion() or 0
		local thisPCT, restPCT = 0, 0
		thisPCT = math.floor(((thisXP/nextXP)*100))
		if restXP > 0 then restPCT = math.floor((((restXP)/nextXP)*100)) end
		Glance.Functions.TTST("Experience", "GLD")
		Glance.Functions.TTAD("Level ", thisLVL, "WHT", "GRN")
		--Glance.Functions.TTAD("Total XP level "..UnitLevel("player").." to "..UnitLevel("player")+1, UnitXPMax('player'),"WHT", "GRN")
		--Glance.Functions.TTAD("Remaing XP to level "..UnitLevel("player")+1, UnitXPMax('player')-UnitXP('player'),"WHT", "GRN")
		Glance.Functions.TTAD("Current XP ", thisPCT.."%", "WHT", "GRN")
		if restXP > 0 then
			Glance.Functions.TTAD("Rested XP ", restPCT.."%", "BLU", "GRN")
		else
			Glance.Functions.TTAD("Rested XP ", restPCT.."%", "PPL", "RED")
		end
	end
end

---------------------------
-- Rep tooltip
---------------------------
function Glance.Functions.setTTRep()
	Glance.Functions.TTST("Reputation", "GLD")
	local hasWatch = false
	for i=1,GetNumFactions() do
		local name,_,_,bottomValue,topValue,earnedValue,_,_,isHeader,_,_,isWatched,_ = GetFactionInfo(i)
		if isWatched then
			hasWatch = true
			Glance.Functions.TTAD("Currently tracking "..Glance.Arrays.colors[Glance.Arrays.rep[""..topValue]]..name.."|r reputation:", Glance.Arrays.colors[Glance.Arrays.rep[""..topValue]]..Glance.Arrays.rep[""..topValue], "WHT", "WHT")
		end
	end
	if not hasWatch then
		Glance.Functions.TTAL("You are not tracking any reputation.", "WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to change Reputation tracking.)","WHT")
end

---------------------------
-- Professions tooltip
---------------------------
function Glance.Functions.setTTProfessions()
	Glance.Functions.TTST("Professions", "GLD")
	local herb,mine = "",""
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	local Professions = {
		[1] = prof1,
		[2] = prof2,
		[3] = archaeology,
		[4] = fishing,
		[5] = cooking,
		[6] = firstAid
	}
	for i=1,6 do
		if Professions[i] ~= nil then
			local pLevel = ""
			local name, icon, skillLevel, maxSkillLevel,_,_,_,_ = GetProfessionInfo(Professions[i])
			if Glance.Arrays.Professions[""..maxSkillLevel] ~= nil then
				pLevel = Glance.Arrays.Professions[""..maxSkillLevel]
			end
			Glance.Functions.TTAD(name..": |cFF69CCF0("..pLevel..")", skillLevel.."/"..maxSkillLevel, "WHT","GRN")
			if name=="Mining" and skillLevel < 525 then
				for i=#Glance.Data.Mining,1,-1 do
					ore, lvl, loc = unpack(Glance.Data.Mining[i])
					if skillLevel >= lvl then mine = "You should be mining |cffff5500"..ore.."|r in: |cffffff00"..loc break end
				end
			end
			if name=="Herbalism" and skillLevel < 525 then
				for i=#Glance.Data.Herbalism,1,-1 do
					ore, lvl, loc = unpack(Glance.Data.Herbalism[i])
					if skillLevel >= lvl then herb = "You should be gathering |cffff5500"..ore.."|r in: |cffffff00"..loc break end
				end
			end
		end
	end
	if mine ~= "" then
		Glance.Functions.TTAL(" ","GLD")
		Glance.Functions.TTAL("Mining","GLD")
		Glance.Functions.TTALW(mine,"WHT")
	end
	if herb ~= "" then
		Glance.Functions.TTAL(" ","GLD")
		Glance.Functions.TTAL("Herbalism","GLD")
		Glance.Functions.TTALW(herb,"WHT")
	end
	Glance.Functions.TTAL(" ","GLD")
	Glance.Functions.TTAL("(Click to change Profession tracking.)","WHT")
end

---------------------------
-- Latency/framerate tooltip
---------------------------
function Glance.Functions.setTTLAG()
	local addons = {}
	local total = 0
	Glance.Functions.TTST("Memory Usage", "GLD")
	UpdateAddOnMemoryUsage()
	for i=1, GetNumAddOns() do
		if IsAddOnLoaded(i) then
			local memory = GetAddOnMemoryUsage(i)
			if memory ~= nil and memory > 0 then
				total = total + memory
				table.insert(addons, {GetAddOnInfo(i), memory})
			end
		end
	end
	table.sort(addons, function(a, b) return a[2] > b[2] end)
	for k, v in pairs(addons) do
		if v[2] > 1000 then
			Glance.Functions.TTAD(format("%s", v[1]), Glance.Functions.FormatMemory(v[2]),"BLU", "RED")
		else
			Glance.Functions.TTAD(format("%s", v[1]), Glance.Functions.FormatMemory(v[2]), "BLU", "GRN")
		end
	end
	Glance.Functions.TTAL(" ","WHT")
	Glance.Functions.TTAD("Total Memory Usage: ", Glance.Functions.FormatMemory(total), "WHT","WHT")
	wipe(addons)
end

---------------------------
-- Mounts tooltip
---------------------------
function Glance.Functions.setTTMounts()
	Glance.Functions.TTST("Mounts", "GLD")
	Glance.Functions.TTALW("Click 'Mounts' to show a dropdown menu of available mounts for your skill and location. Select one to mount or dismount.","WHT")
end

---------------------------
-- Pets tooltip
---------------------------
function Glance.Functions.setTTPets()
	Glance.Functions.TTST("Pets", "GLD")
	Glance.Functions.TTALW("Click 'Pets' to show a dropdown menu of available companion pets for you to select and summon.","WHT")
end


---------------------------
-- Wintergrasp tooltip
---------------------------
function Glance.Functions.setTTWG()
	Glance.Functions.TTST("Wintergrasp", "GLD")
	SetMapToCurrentZone()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(1)
	--local sec = GetWintergraspWaitTime()
	local control = "|r"
	SetMapByID(485) --708 for tol barad
	for i = 1, GetNumMapLandmarks() do
		local index = select(3, GetMapLandmarkInfo(i))
		if index == 46 then
			control = "|cFF69CCF0Alliance"
		elseif index == 48 then
			control = "|cFFC41F3BHorde"
		end
	end
	if not isActive then
		if (control=="|r") then
			Glance.Functions.TTAL("|rControl of "..localizedName.." cannot be determined.", "WHT")
			Glance.Functions.TTAL("|rYou must be in Northrend at least once this session.", "WHT")
		else
			Glance.Functions.TTAL("|r"..localizedName.." is in "..control.." |rcontrol.", "WHT")
		end
	else
		Glance.Functions.TTAL("|rThe battle for Lake "..localizedName.." is in progress.", "WHT")
	end
end

---------------------------
-- Tol Barad tooltip
---------------------------
function Glance.Functions.setTTTB()
	Glance.Functions.TTST("Tol Barad", "GLD")
	SetMapToCurrentZone()
	local pvpID, localizedName, isActive, canQueue, sec, canEnter = GetWorldPVPAreaInfo(2)
	local control = "|r"
	SetMapByID(708) 
	for i = 1, GetNumMapLandmarks() do
		local index = select(3, GetMapLandmarkInfo(i))
		if index == 46 then
			control = "|cFF69CCF0Alliance"
		elseif index == 48 then
			control = "|cFFC41F3BHorde"
		end
	end
	if not isActive then
		if (control=="|r") then
			Glance.Functions.TTAL("|rControl of "..localizedName.." cannot be determined.", "WHT")
			Glance.Functions.TTAL("|rYou must be in Tol Barad at least once this session.", "WHT")
		else
			Glance.Functions.TTAL("|r"..localizedName.." is in "..control.." |rcontrol.", "WHT")
		end
	else
		Glance.Functions.TTAL("|rThe battle for "..localizedName.." is in progress.", "WHT")
	end
end